#include <QApplication>
#include <QLayout>
#include <QMainWindow>
#include <QToolBar>
#include <QLabel>
#include <private/qobject_p.h>
#include <private/qwidget_p.h>


void printLayoutItems(QLayout* layout) {
  if (layout != nullptr) {
    int counter = 0;
    auto item = layout->itemAt(0);
    while (item != nullptr) {
      QLayoutItem* widgetItemOfWidget = nullptr;
      if (item->widget() != nullptr) {
        auto *wd = static_cast<QWidgetPrivate*>(QObjectPrivate::get(item->widget()));
        widgetItemOfWidget = wd->widgetItem;
      }
      qDebug() << counter << item << item->widget()
               << static_cast<void*>(widgetItemOfWidget);
      ++counter;
      item = layout->itemAt(counter);
    }
  }
}


int main(int argc, char *argv[]) {
  QApplication a(argc, argv);
  QMainWindow* w = new QMainWindow;

  QToolBar* simpleToolBar = new QToolBar();
  simpleToolBar->setObjectName("simpleToolBar");
  simpleToolBar->addWidget(new QLabel("Test"));
  w->addToolBar(simpleToolBar);
  w->show();

  qDebug() << "Before restore";
  printLayoutItems(w->layout());
  auto state = w->saveState();
  w->restoreState(state);
  qDebug() << "After restore";
  printLayoutItems(w->layout());

  return a.exec();
}
